/**
 * generated by Xtext 2.9.1
 */
package de.fhmuenster.masterthesis.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterators;
import de.fhmuenster.masterthesis.generator.mockdata.DelegateMock;
import de.fhmuenster.masterthesis.generator.mockdata.ExternalServiceMock;
import de.fhmuenster.masterthesis.generator.mockdata.IsMock;
import de.fhmuenster.masterthesis.generator.mockdata.ManualMock;
import de.fhmuenster.masterthesis.generator.testdata.IsTestProgressCheck;
import de.fhmuenster.masterthesis.generator.testdata.IsTeststep;
import de.fhmuenster.masterthesis.generator.testdata.NotPassedCheck;
import de.fhmuenster.masterthesis.generator.testdata.PassedCheck;
import de.fhmuenster.masterthesis.generator.testdata.ProcessEndedCheck;
import de.fhmuenster.masterthesis.generator.testdata.ProcessStartedCheck;
import de.fhmuenster.masterthesis.generator.testdata.TestExternalTask;
import de.fhmuenster.masterthesis.generator.testdata.TestProgressCheck;
import de.fhmuenster.masterthesis.generator.testdata.TestStart;
import de.fhmuenster.masterthesis.generator.testdata.TestTask;
import de.fhmuenster.masterthesis.generator.testdata.Testcase;
import de.fhmuenster.masterthesis.generator.testdata.VariableValuePair;
import de.fhmuenster.masterthesis.generator.testdata.VariablesCheck;
import de.fhmuenster.masterthesis.generator.utils.TestgeneratorClassUtils;
import de.fhmuenster.masterthesis.testgeneratorDSL.BPMNDiagram;
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableDeclaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariableNotEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.BusinessRuleTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.DelegateServiceTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.EndCheck;
import de.fhmuenster.masterthesis.testgeneratorDSL.EndChecks;
import de.fhmuenster.masterthesis.testgeneratorDSL.EndFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.Flow;
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElementReference;
import de.fhmuenster.masterthesis.testgeneratorDSL.GatewayFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableDeclaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariableNotEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.ManualTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.MockReference;
import de.fhmuenster.masterthesis.testgeneratorDSL.ScriptTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.SequenceFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.StartFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableDeclaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariableNotEquals;
import de.fhmuenster.masterthesis.testgeneratorDSL.Test;
import de.fhmuenster.masterthesis.testgeneratorDSL.UserTaskFlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.VariableDeclaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.VariableDeclarations;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class TestgeneratorDSLGenerator extends AbstractGenerator {
  private String testcollectionPackageName = "";
  
  private String testcollectionFilePath = "";
  
  private StringBuilder codegeneratorTests;
  
  private HashMap<String, HashMap<String, Object>> globalTaskVariables;
  
  private Map<String, String> globalExternalTopicsMap;
  
  private Map<String, BPMNGenDiagram> diagramMap;
  
  private Map<String, BPMNGenFlow> flowMap;
  
  private List<BPMNGenFlowElement> flowElements;
  
  private List<DelegateMock> delegateMocks;
  
  private List<ExternalServiceMock> externalServiceMocks;
  
  private FlowElementDefinitionGenerator flowElementDefinitionGenerator;
  
  private static final String CARRIAGE_RETURN = "\r\n";
  
  private static final String FILE_EXTENSION = ".bpmn-testgen";
  
  private static final String FILE_NAME = "%s.java";
  
  private static final String TEST_UTILS_FILENAME = "TestUtils";
  
  private static final String CLASS_DECLARATION = "public class %s {";
  
  private static final String VARIABLE_DECLARATION = "\tprivate static final String %s = \"%s\";";
  
  private static final String TESTCASE_DEPLOYMENT = "\t@Deployment(resources = {%s})";
  
  private static final String TESTCASE_SINGLE_DEPLOYMENT = "\"%s\"";
  
  private static final String TESTCASE_METHOD = "\tpublic void %s() {";
  
  private static final String EXTERNALSERVICEMOCKPROVIDER_NAME = "ExternalServiceMockProvider";
  
  private static final String EXTERNALSERVICEMOCKPROVIDER_FILENAME = (TestgeneratorDSLGenerator.EXTERNALSERVICEMOCKPROVIDER_NAME + ".java");
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    StringBuilder _stringBuilder = new StringBuilder();
    this.codegeneratorTests = _stringBuilder;
    HashMap<String, String> _hashMap = new HashMap<String, String>();
    this.globalExternalTopicsMap = _hashMap;
    HashMap<String, HashMap<String, Object>> _hashMap_1 = new HashMap<String, HashMap<String, Object>>();
    this.globalTaskVariables = _hashMap_1;
    HashMap<String, BPMNGenDiagram> _hashMap_2 = new HashMap<String, BPMNGenDiagram>();
    this.diagramMap = _hashMap_2;
    HashMap<String, BPMNGenFlow> _hashMap_3 = new HashMap<String, BPMNGenFlow>();
    this.flowMap = _hashMap_3;
    ArrayList<BPMNGenFlowElement> _arrayList = new ArrayList<BPMNGenFlowElement>();
    this.flowElements = _arrayList;
    ArrayList<DelegateMock> _arrayList_1 = new ArrayList<DelegateMock>();
    this.delegateMocks = _arrayList_1;
    ArrayList<ExternalServiceMock> _arrayList_2 = new ArrayList<ExternalServiceMock>();
    this.externalServiceMocks = _arrayList_2;
    this.prepareDelegateMocks(resource);
    this.prepareExternalServiceMocks(resource);
    this.prepareGlobalExternalTopics(resource);
    this.prepareGlobalTaskVariables(resource);
    this.prepareBPMNDiagrams(resource);
    this.prepareBPMNFlows(resource);
    this.prepareFlowElements(resource);
    this.createMockClasses(fsa);
    this.createFlowElementDefinitionClasses(fsa);
    this.createUtilClasses(fsa);
    this.createTestcollection(fsa, resource);
  }
  
  public void createMockClasses(final IFileSystemAccess2 fsa) {
    final ExternalServiceMockGenerator externalMockGenerator = new ExternalServiceMockGenerator(this.externalServiceMocks, 
      this.testcollectionPackageName);
    externalMockGenerator.generateMock();
    fsa.generateFile(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.EXTERNALSERVICEMOCKPROVIDER_FILENAME), 
      externalMockGenerator.getMockCode());
  }
  
  public void createFlowElementDefinitionClasses(final IFileSystemAccess2 fsa) {
    FlowElementDefinitionGenerator _flowElementDefinitionGenerator = new FlowElementDefinitionGenerator(this.flowElements, this.testcollectionPackageName);
    this.flowElementDefinitionGenerator = _flowElementDefinitionGenerator;
    this.flowElementDefinitionGenerator.generateCode();
    final String filenameUserTasks = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.USER_TASK_NAME);
    fsa.generateFile(filenameUserTasks, this.flowElementDefinitionGenerator.getUserTaskCode());
    final String filenameManualTasks = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.MANUAL_TASK_NAME);
    fsa.generateFile(filenameManualTasks, this.flowElementDefinitionGenerator.getManualTaskCode());
    final String filenameScriptTasks = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.SCRIPT_TASK_NAME);
    fsa.generateFile(filenameScriptTasks, this.flowElementDefinitionGenerator.getScriptTaskCode());
    final String filenameServiceTasks = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.SERVICE_TASK_NAME);
    fsa.generateFile(filenameServiceTasks, this.flowElementDefinitionGenerator.getServiceTaskCode());
    final String filenameBusinessRuleTasks = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.BUSINESS_RULE_NAME);
    fsa.generateFile(filenameBusinessRuleTasks, this.flowElementDefinitionGenerator.getBusinessRuleTaskCode());
    final String filenameGateways = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), 
      NameProvider.GATEWAYS_NAME);
    fsa.generateFile(filenameGateways, this.flowElementDefinitionGenerator.getGatewayCode());
    final String filenameEvents = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), NameProvider.EVENTS_NAME);
    fsa.generateFile(filenameEvents, this.flowElementDefinitionGenerator.getEventCode());
  }
  
  public void createUtilClasses(final IFileSystemAccess2 fsa) {
    final TestUtilsGenerator generator = new TestUtilsGenerator(this.testcollectionPackageName);
    generator.generateUtils();
    final String filenameUtils = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), TestgeneratorDSLGenerator.TEST_UTILS_FILENAME);
    fsa.generateFile(filenameUtils, generator.getUtilsCode());
  }
  
  public void createTestcollection(final IFileSystemAccess2 fsa, final Resource resource) {
    final List<String> segments = resource.getURI().segmentsList();
    int _size = segments.size();
    int _minus = (_size - 1);
    final String filenamePrefix = segments.get(_minus).replace(TestgeneratorDSLGenerator.FILE_EXTENSION, "");
    this.generateTestcollection(resource, filenamePrefix);
    final String testContent = this.codegeneratorTests.toString();
    final String filenameTestcollection = String.format(((this.testcollectionFilePath + "//") + TestgeneratorDSLGenerator.FILE_NAME), filenamePrefix);
    fsa.generateFile(filenameTestcollection, testContent);
  }
  
  public StringBuilder generateTestcollection(final Resource resource, final String testcollectionName) {
    StringBuilder _xblockexpression = null;
    {
      this.addPackageDeclaration(this.testcollectionPackageName, this.codegeneratorTests);
      this.addSeparatorLine();
      this.addAssertImports();
      this.addSeparatorLine();
      this.addImports();
      this.addSeparatorLine();
      this.addClassHeader(testcollectionName, this.codegeneratorTests);
      this.addSeparatorLine();
      this.addRule();
      this.addSeparatorLine();
      this.addVariableDeclarations(this.getVariables(resource));
      this.addSeparatorLine();
      this.addLogging();
      this.addSeparatorLine();
      this.addSetup();
      this.addTests(this.getTests(resource));
      _xblockexpression = this.addClassClosing(this.codegeneratorTests);
    }
    return _xblockexpression;
  }
  
  public StringBuilder addPackageDeclaration(final String packageName, final StringBuilder builder) {
    return this.appendLine(NameProvider.getPackageDeclaration(packageName), builder);
  }
  
  public StringBuilder addAssertImports() {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("import static org.camunda.bpm.engine.test.assertions.ProcessEngineTests.*;");
      this.appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.complete;");
      this.appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.runtimeService;");
      this.appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.task;");
      this.appendLine("import static org.camunda.bpm.engine.test.assertions.bpmn.BpmnAwareTests.withVariables;");
      this.appendLine("import static org.assertj.core.api.Assertions.entry;");
      _xblockexpression = this.appendLine(String.format("import static %s.TestUtils.*;", this.testcollectionPackageName));
    }
    return _xblockexpression;
  }
  
  public StringBuilder addImports() {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("import org.apache.ibatis.logging.LogFactory;");
      this.appendLine("import org.camunda.bpm.engine.runtime.ProcessInstance;");
      this.appendLine("import org.camunda.bpm.engine.test.Deployment;");
      this.appendLine("import org.camunda.bpm.engine.test.ProcessEngineRule;");
      this.appendLine("import org.camunda.bpm.engine.externaltask.LockedExternalTask;");
      boolean _isEmpty = this.delegateMocks.isEmpty();
      boolean _not = (!_isEmpty);
      if (_not) {
        this.appendLine("import org.camunda.bpm.engine.test.mock.Mocks;");
        final Function<DelegateMock, Stream<ManualMock>> _function = (DelegateMock it) -> {
          return it.getManualMocks().stream();
        };
        final Function<ManualMock, String> _function_1 = (ManualMock it) -> {
          return it.getPackageName();
        };
        final Function<DelegateMock, String> _function_2 = (DelegateMock it) -> {
          return it.getPackageName();
        };
        final Predicate<String> _function_3 = (String packageName) -> {
          return packageName.replace((this.testcollectionPackageName + "."), "").contains(".");
        };
        final List<String> packages = Stream.<String>concat(
          this.delegateMocks.stream().<ManualMock>flatMap(_function).<String>map(_function_1), 
          this.delegateMocks.stream().<String>map(_function_2)).distinct().filter(_function_3).collect(
          Collectors.<String>toList());
        final Consumer<String> _function_4 = (String packageName) -> {
          this.appendLine(String.format("import %s;", packageName));
        };
        packages.forEach(_function_4);
      }
      this.appendLine(
        "import org.camunda.bpm.extension.process_test_coverage.junit.rules.TestCoverageProcessEngineRuleBuilder;");
      this.appendLine("import org.junit.Before;");
      this.appendLine("import org.junit.ClassRule;");
      this.appendLine("import org.junit.Rule;");
      this.appendLine("import org.junit.Test;");
      this.appendLine("import java.util.List;");
      _xblockexpression = this.appendLine("import java.util.Map;");
    }
    return _xblockexpression;
  }
  
  public StringBuilder addClassHeader(final String className, final StringBuilder builder) {
    return this.appendLine(String.format(TestgeneratorDSLGenerator.CLASS_DECLARATION, className), builder);
  }
  
  public StringBuilder addRule() {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("\t@ClassRule");
      this.appendLine("\t@Rule");
      _xblockexpression = this.appendLine("\tpublic static ProcessEngineRule rule = TestCoverageProcessEngineRuleBuilder.create().build();");
    }
    return _xblockexpression;
  }
  
  public void addVariableDeclarations(final List<String> testvariables) {
    final Consumer<String> _function = (String it) -> {
      this.addVariableDeclaration(it);
    };
    testvariables.forEach(_function);
  }
  
  public StringBuilder addVariableDeclaration(final String variableName) {
    return this.appendLine(
      String.format(TestgeneratorDSLGenerator.VARIABLE_DECLARATION, NameProvider.getStaticFinalVariableName(variableName), variableName));
  }
  
  public StringBuilder addLogging() {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("\tstatic {");
      this.appendLine("\t\tLogFactory.useSlf4jLogging();");
      _xblockexpression = this.appendLine("\t}");
    }
    return _xblockexpression;
  }
  
  public StringBuilder addSetup() {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("\t@Before");
      this.appendLine("\tpublic void setup() {");
      this.appendLine("\t\tinit(rule.getProcessEngine());");
      boolean _isEmpty = this.delegateMocks.isEmpty();
      boolean _not = (!_isEmpty);
      if (_not) {
        this.addSeparatorLine();
        this.addDelegateMockSetup();
      }
      _xblockexpression = this.appendLine("\t}");
    }
    return _xblockexpression;
  }
  
  public void addDelegateMockSetup() {
    final Map<String, String> mocksToRegister = new HashMap<String, String>();
    for (final DelegateMock mock : this.delegateMocks) {
      {
        final Map<String, String> manualMocks = new HashMap<String, String>();
        List<ManualMock> _manualMocks = mock.getManualMocks();
        for (final ManualMock manualMock : _manualMocks) {
          {
            final String manualMockClassName = manualMock.getClassName();
            final String manualMockVariableName = TestgeneratorClassUtils.getVariableName(manualMockClassName);
            final String manualMockSetter = manualMock.getSetter();
            this.appendLine(
              String.format("\t\t%s %s = new %s();", manualMockClassName, manualMockVariableName, manualMockClassName));
            manualMocks.put(manualMockVariableName, manualMockSetter);
          }
        }
        this.addSeparatorLine();
        final String delegateClassName = mock.getDelegateClassName();
        final String variableName = TestgeneratorClassUtils.getVariableName(delegateClassName);
        final String registrationName = mock.getRegistrationName();
        this.appendLine(String.format("\t\t%s %s = new %s();", delegateClassName, variableName, delegateClassName));
        Set<Map.Entry<String, String>> _entrySet = manualMocks.entrySet();
        for (final Map.Entry<String, String> entry : _entrySet) {
          this.appendLine(String.format("\t\t%s.%s(%s);", variableName, entry.getValue(), entry.getKey()));
        }
        mocksToRegister.put(variableName, registrationName);
      }
    }
    this.addSeparatorLine();
    Set<Map.Entry<String, String>> _entrySet = mocksToRegister.entrySet();
    for (final Map.Entry<String, String> entry : _entrySet) {
      this.appendLine(String.format("\t\tMocks.register(\"%s\", %s);", entry.getValue(), entry.getKey()));
    }
  }
  
  public void addTests(final List<Test> testcases) {
    for (final Test testcase : testcases) {
      {
        this.addSeparatorLine();
        this.addTest(testcase);
      }
    }
  }
  
  public StringBuilder addTest(final Test test) {
    StringBuilder _xblockexpression = null;
    {
      final BPMNGenTestcase bpmnTestcase = this.getBPMNTestcase(test);
      final BPMNGenDiagram bpmnDiagram = bpmnTestcase.getFlow().getBpmnDiagram();
      final BPMNTestcollectionCreator c = new BPMNTestcollectionCreator().withProcessIntanceKey(
        bpmnDiagram.getProcessInstanceKey());
      final Testcase testcase = c.build(bpmnTestcase);
      this.appendLine("\t@Test");
      this.addDeployment(bpmnDiagram.getDeployments());
      this.appendLine(String.format(TestgeneratorDSLGenerator.TESTCASE_METHOD, test.getName()));
      this.addSeparatorLine();
      int variableSnapshotCounter = 0;
      int externalTaskCounter = 0;
      List<IsTeststep> _teststeps = testcase.getTeststeps();
      for (final IsTeststep teststep : _teststeps) {
        {
          if ((teststep instanceof TestStart)) {
            this.addProcessStart(((TestStart)teststep));
          }
          if ((teststep instanceof TestProgressCheck)) {
            this.addProgressCheck(((TestProgressCheck)teststep));
          }
          if ((teststep instanceof TestTask)) {
            this.addTask(((TestTask)teststep));
          }
          if ((teststep instanceof TestExternalTask)) {
            this.addExternalTask(((TestExternalTask)teststep), variableSnapshotCounter, externalTaskCounter);
            variableSnapshotCounter++;
            externalTaskCounter++;
          }
          this.addSeparatorLine();
        }
      }
      _xblockexpression = this.appendLine("\t}");
    }
    return _xblockexpression;
  }
  
  public StringBuilder addDeployment(final List<String> deployments) {
    StringBuilder _xblockexpression = null;
    {
      final List<String> deploymentList = new ArrayList<String>();
      for (final String deployment : deployments) {
        deploymentList.add(String.format(TestgeneratorDSLGenerator.TESTCASE_SINGLE_DEPLOYMENT, deployment.replace("\\", "\\\\")));
      }
      final String joinedDeployments = String.join(", ", deploymentList);
      _xblockexpression = this.appendLine(String.format(TestgeneratorDSLGenerator.TESTCASE_DEPLOYMENT, joinedDeployments));
    }
    return _xblockexpression;
  }
  
  public StringBuilder addProcessStart(final TestStart testStart) {
    StringBuilder _xblockexpression = null;
    {
      this.appendLine("\t\tProcessInstance processInstance = runtimeService() //");
      final String joinedVariables = this.variables(testStart.getVariableKeyValues());
      StringBuilder _xifexpression = null;
      if ((joinedVariables == null)) {
        _xifexpression = this.appendLine(
          String.format("\t\t\t.startProcessInstanceByKey(\"%s\"); //", 
            testStart.getProcessInstanceKey()));
      } else {
        _xifexpression = this.appendLine(
          String.format("\t\t\t.startProcessInstanceByKey(\"%s\", withVariables(%s)); //", 
            testStart.getProcessInstanceKey(), joinedVariables));
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  public void addProgressCheck(final TestProgressCheck progressCheck) {
    this.appendLine("\t\tassertThat(processInstance) //");
    final Iterator<IsTestProgressCheck> progressChecksIterator = progressCheck.getProgressChecks().iterator();
    while (progressChecksIterator.hasNext()) {
      {
        final IsTestProgressCheck check = progressChecksIterator.next();
        if ((check instanceof PassedCheck)) {
          this.addAssertPassed(((PassedCheck)check));
        }
        if ((check instanceof NotPassedCheck)) {
          this.addAssertNotPassed(((NotPassedCheck)check));
        }
        if ((check instanceof ProcessStartedCheck)) {
          this.addAssertStarted(((ProcessStartedCheck)check));
        }
        if ((check instanceof VariablesCheck)) {
          this.addAssertVariables(((VariablesCheck)check));
        }
        if ((check instanceof ProcessEndedCheck)) {
          this.addAssertEnded(((ProcessEndedCheck)check));
        }
        boolean _hasNext = progressChecksIterator.hasNext();
        boolean _not = (!_hasNext);
        this.appendLine(this.codeformatLine(_not));
      }
    }
  }
  
  public StringBuilder addAssertPassed(final PassedCheck passedCheck) {
    return this.append(
      String.format("\t\t\t.hasPassed(%s)", 
        this.getFlowElementReference(passedCheck.getFlowElementType(), passedCheck.getTaskId())));
  }
  
  public StringBuilder addAssertNotPassed(final NotPassedCheck notPassedCheck) {
    return this.append(
      String.format("\t\t\t.hasNotPassed(%s)", 
        this.getFlowElementReference(notPassedCheck.getFlowElementType(), notPassedCheck.getTaskId())));
  }
  
  public StringBuilder addAssertStarted(final ProcessStartedCheck startedCheck) {
    StringBuilder _xifexpression = null;
    boolean _isStarted = startedCheck.isStarted();
    if (_isStarted) {
      _xifexpression = this.append("\t\t\t.isStarted()");
    }
    return _xifexpression;
  }
  
  public StringBuilder addAssertEnded(final ProcessEndedCheck endedCheck) {
    StringBuilder _xifexpression = null;
    boolean _isEnded = endedCheck.isEnded();
    if (_isEnded) {
      _xifexpression = this.append("\t\t\t.isEnded()");
    } else {
      _xifexpression = this.append("\t\t\t.isNotEnded()");
    }
    return _xifexpression;
  }
  
  public StringBuilder addAssertVariables(final VariablesCheck variablesCheck) {
    StringBuilder _xblockexpression = null;
    {
      final List<VariableValuePair> checksEquals = variablesCheck.getVariableEqualsChecks();
      final List<VariableValuePair> checksNotEquals = variablesCheck.getVariableNotEqualsChecks();
      if (((!checksEquals.isEmpty()) || (!checksNotEquals.isEmpty()))) {
        this.append("\t\t\t.variables()");
        this.appendLine(this.codeformatLine(false));
      }
      boolean _isEmpty = checksEquals.isEmpty();
      boolean _not = (!_isEmpty);
      if (_not) {
        final String entries = this.entries(checksEquals);
        this.append(String.format("\t\t\t\t.contains(%s)", entries));
        boolean _isEmpty_1 = checksNotEquals.isEmpty();
        boolean _not_1 = (!_isEmpty_1);
        if (_not_1) {
          this.appendLine(this.codeformatLine(false));
        }
      }
      StringBuilder _xifexpression = null;
      boolean _isEmpty_2 = checksNotEquals.isEmpty();
      boolean _not_2 = (!_isEmpty_2);
      if (_not_2) {
        StringBuilder _xblockexpression_1 = null;
        {
          final String entries_1 = this.entries(checksNotEquals);
          _xblockexpression_1 = this.append(String.format("\t\t\t\t.doesNotContain(%s)", entries_1));
        }
        _xifexpression = _xblockexpression_1;
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  public String entries(final List<VariableValuePair> variableValuePairs) {
    final List<String> entries = new ArrayList<String>();
    for (final VariableValuePair pair : variableValuePairs) {
      entries.add(String.format("entry(%s, %s)", NameProvider.getStaticFinalVariableName(pair.getVariable()), this.variable(pair.getValue())));
    }
    return String.join(", ", entries);
  }
  
  public StringBuilder addTask(final TestTask task) {
    StringBuilder _xblockexpression = null;
    {
      final HashMap<String, Object> variables = task.getVariableKeyValues();
      final String joinedVariables = this.variables(variables);
      final String taskName = this.getFlowElementReference(FlowElementType.USER_TASK, task.getName());
      StringBuilder _xifexpression = null;
      if ((joinedVariables == null)) {
        _xifexpression = this.appendLine(String.format("\t\tcomplete(task(%s));", taskName));
      } else {
        _xifexpression = this.appendLine(String.format("\t\tcomplete(task(%s), withVariables(%s));", taskName, joinedVariables));
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  public StringBuilder addExternalTask(final TestExternalTask task, final int variableSnapshotCounter, final int externalTaskCounter) {
    StringBuilder _xblockexpression = null;
    {
      final String taskName = this.getFlowElementReference(FlowElementType.SERVICE_TASK_EXTERNAL, task.getName());
      final HashMap<String, Object> hardcodedVariableValues = task.getHardcodedVariableValues();
      String _xifexpression = null;
      String _externalMockName = task.getExternalMockName();
      boolean _notEquals = (!Objects.equal(_externalMockName, null));
      if (_notEquals) {
        _xifexpression = task.getExternalMockName();
      } else {
        _xifexpression = "";
      }
      final String externalMockName = _xifexpression;
      this.appendLine(
        String.format("\t\tMap<String, Object> variableSnapshot%s = runtimeService() //", Integer.valueOf(variableSnapshotCounter)));
      this.appendLine("\t\t\t.getVariables(processInstance.getId()); //");
      final Consumer<Map.Entry<String, Object>> _function = (Map.Entry<String, Object> entry) -> {
        final String variableName = NameProvider.getStaticFinalVariableName(entry.getKey());
        final String variableValue = this.variable(entry.getValue());
        this.appendLine(String.format("\t\tvariableSnapshot%s.put(%s, %s);", Integer.valueOf(variableSnapshotCounter), variableName, variableValue));
      };
      hardcodedVariableValues.entrySet().stream().forEach(_function);
      if ((externalTaskCounter == 0)) {
        this.appendLine(String.format("\t\tList<LockedExternalTask> lockedTasks%s = lockTasks(\"%s\");", Integer.valueOf(externalTaskCounter), task.getTopic()));
      } else {
        this.appendLine(String.format("\t\tList<LockedExternalTask> lockedTasks%s = lockTasks(lockedTasks%s, \"%s\");", Integer.valueOf(externalTaskCounter), Integer.valueOf((externalTaskCounter - 1)), task.getTopic()));
      }
      _xblockexpression = this.appendLine(
        String.format("\t\tcomplete(getLockedTask(lockedTasks%s, %s), ExternalServiceMockProvider.%s(variableSnapshot%s));", Integer.valueOf(externalTaskCounter), taskName, externalMockName, Integer.valueOf(variableSnapshotCounter)));
    }
    return _xblockexpression;
  }
  
  public StringBuilder addClassClosing(final StringBuilder builder) {
    return this.appendLine("}", builder);
  }
  
  public StringBuilder append(final String text) {
    return this.codegeneratorTests.append(text);
  }
  
  public StringBuilder appendLine(final String line) {
    StringBuilder _xblockexpression = null;
    {
      this.codegeneratorTests.append(line);
      _xblockexpression = this.codegeneratorTests.append(TestgeneratorDSLGenerator.CARRIAGE_RETURN);
    }
    return _xblockexpression;
  }
  
  public StringBuilder addSeparatorLine() {
    return this.codegeneratorTests.append(TestgeneratorDSLGenerator.CARRIAGE_RETURN);
  }
  
  public StringBuilder append(final String text, final StringBuilder builder) {
    return builder.append(text);
  }
  
  public StringBuilder appendLine(final String line, final StringBuilder builder) {
    StringBuilder _xblockexpression = null;
    {
      builder.append(line);
      _xblockexpression = builder.append(TestgeneratorDSLGenerator.CARRIAGE_RETURN);
    }
    return _xblockexpression;
  }
  
  public StringBuilder addSeparatorLine(final StringBuilder builder) {
    return builder.append(TestgeneratorDSLGenerator.CARRIAGE_RETURN);
  }
  
  public String codeformatLine(final boolean lastLine) {
    if (lastLine) {
      return "; //";
    } else {
      return " //";
    }
  }
  
  public String variables(final HashMap<String, Object> variables) {
    final Function<Map.Entry<String, Object>, String> _function = (Map.Entry<String, Object> entry) -> {
      return String.join(", ", entry.getKey(), this.variable(entry.getValue()));
    };
    final List<String> variableList = variables.entrySet().stream().<String>map(_function).collect(Collectors.<String>toList());
    boolean _isEmpty = variableList.isEmpty();
    boolean _not = (!_isEmpty);
    if (_not) {
      return String.join(", ", variableList);
    }
    return null;
  }
  
  public String variable(final Object variable) {
    if ((variable instanceof String)) {
      return (("\"" + ((String)variable)) + "\"");
    }
    return variable.toString();
  }
  
  public List<String> getVariables(final Resource resource) {
    final Function1<StringVariable, String> _function = (StringVariable it) -> {
      return it.getName();
    };
    final List<String> stringVariables = IteratorExtensions.<String>toList(IteratorExtensions.<StringVariable, String>map(Iterators.<StringVariable>filter(resource.getAllContents(), StringVariable.class), _function));
    final Function1<IntVariable, String> _function_1 = (IntVariable it) -> {
      return it.getName();
    };
    final List<String> intVariables = IteratorExtensions.<String>toList(IteratorExtensions.<IntVariable, String>map(Iterators.<IntVariable>filter(resource.getAllContents(), IntVariable.class), _function_1));
    final Function1<BooleanVariable, String> _function_2 = (BooleanVariable it) -> {
      return it.getName();
    };
    final List<String> booleanVariables = IteratorExtensions.<String>toList(IteratorExtensions.<BooleanVariable, String>map(Iterators.<BooleanVariable>filter(resource.getAllContents(), BooleanVariable.class), _function_2));
    final List<String> allVariables = new ArrayList<String>();
    allVariables.addAll(stringVariables);
    allVariables.addAll(intVariables);
    allVariables.addAll(booleanVariables);
    return allVariables;
  }
  
  public String getFlowElementReference(final FlowElementType flowElementType, final String flowElement) {
    String clazz = "";
    boolean _equals = FlowElementType.USER_TASK.equals(flowElementType);
    if (_equals) {
      clazz = NameProvider.USER_TASK_NAME;
    } else {
      boolean _equals_1 = FlowElementType.MANUAL_TASK.equals(flowElementType);
      if (_equals_1) {
        clazz = NameProvider.MANUAL_TASK_NAME;
      } else {
        boolean _equals_2 = FlowElementType.SCRIPT_TASK.equals(flowElementType);
        if (_equals_2) {
          clazz = NameProvider.SCRIPT_TASK_NAME;
        } else {
          boolean _equals_3 = FlowElementType.SERVICE_TASK_DELEGATE.equals(flowElementType);
          if (_equals_3) {
            clazz = NameProvider.SERVICE_TASK_NAME;
          } else {
            boolean _equals_4 = FlowElementType.SERVICE_TASK_EXTERNAL.equals(flowElementType);
            if (_equals_4) {
              clazz = NameProvider.SERVICE_TASK_NAME;
            } else {
              boolean _equals_5 = FlowElementType.BUSINESS_RULE_TASK.equals(flowElementType);
              if (_equals_5) {
                clazz = NameProvider.BUSINESS_RULE_NAME;
              } else {
                boolean _equals_6 = FlowElementType.GATEWAY.equals(flowElementType);
                if (_equals_6) {
                  clazz = NameProvider.GATEWAYS_NAME;
                } else {
                  boolean _equals_7 = FlowElementType.START_EVENT.equals(flowElementType);
                  if (_equals_7) {
                    clazz = NameProvider.EVENTS_NAME;
                  } else {
                    boolean _equals_8 = FlowElementType.END_EVENT.equals(flowElementType);
                    if (_equals_8) {
                      clazz = NameProvider.EVENTS_NAME;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    String _staticFinalFlowElementName = NameProvider.getStaticFinalFlowElementName(flowElementType, flowElement);
    return ((clazz + ".") + _staticFinalFlowElementName);
  }
  
  public List<Test> getTests(final Resource resource) {
    return IteratorExtensions.<Test>toList(Iterators.<Test>filter(resource.getAllContents(), Test.class));
  }
  
  public void prepareBPMNDiagrams(final Resource resource) {
    final List<BPMNDiagram> diagrams = IteratorExtensions.<BPMNDiagram>toList(Iterators.<BPMNDiagram>filter(resource.getAllContents(), BPMNDiagram.class));
    for (final BPMNDiagram diagram : diagrams) {
      {
        final BPMNGenDiagram bpmnDiagram = new BPMNGenDiagram();
        this.testcollectionPackageName = diagram.getTestpackage();
        this.testcollectionFilePath = diagram.getTestpackage().replace(".", "//");
        bpmnDiagram.setTestpackage(diagram.getTestpackage());
        bpmnDiagram.setBpmn(diagram.getBpmn());
        bpmnDiagram.setProcessInstanceKey(diagram.getKey());
        bpmnDiagram.setDmns(diagram.getDmn());
        this.diagramMap.put(diagram.getName(), bpmnDiagram);
      }
    }
  }
  
  public void prepareBPMNFlows(final Resource resource) {
    final List<Flow> flows = IteratorExtensions.<Flow>toList(Iterators.<Flow>filter(resource.getAllContents(), Flow.class));
    for (final Flow f : flows) {
      {
        final List<BPMNGenFlowElement> flowElements = new ArrayList<BPMNGenFlowElement>();
        final String bpmnName = f.getBpmnReference().getRef().getName();
        final BPMNGenDiagram diagram = this.diagramMap.get(bpmnName);
        EList<FlowElementReference> _inclElements = f.getInclElements();
        for (final FlowElementReference r : _inclElements) {
          {
            final BPMNGenFlowElement flowElement = this.createBPMNGenFlowElement(r.getRef());
            flowElements.add(flowElement);
          }
        }
        final List<BPMNGenFlowElement> exclusiveFlowElements = new ArrayList<BPMNGenFlowElement>();
        EList<FlowElementReference> _exclElements = f.getExclElements();
        for (final FlowElementReference r_1 : _exclElements) {
          {
            final BPMNGenFlowElement flowElement = this.createBPMNGenFlowElement(r_1.getRef());
            exclusiveFlowElements.add(flowElement);
          }
        }
        final BPMNGenFlow flow = new BPMNGenFlow();
        flow.setBpmnDiagram(diagram);
        flow.setName(f.getName());
        flow.setFlowElements(flowElements);
        flow.setExclusiveFlowElements(exclusiveFlowElements);
        this.flowMap.put(f.getName(), flow);
      }
    }
  }
  
  public void prepareFlowElements(final Resource resource) {
    final List<FlowElement> flowElements = IteratorExtensions.<FlowElement>toList(Iterators.<FlowElement>filter(resource.getAllContents(), FlowElement.class));
    for (final FlowElement f : flowElements) {
      {
        final FlowElementType type = this.getFlowElementType(f);
        boolean _isDeclarationType = this.isDeclarationType(type);
        if (_isDeclarationType) {
          final BPMNGenFlowElement flowElement = this.createBPMNGenFlowElement(f);
          this.flowElements.add(flowElement);
        }
      }
    }
  }
  
  public List<DelegateMock> prepareDelegateMocks(final Resource resource) {
    List<DelegateMock> _xblockexpression = null;
    {
      final List<de.fhmuenster.masterthesis.testgeneratorDSL.DelegateMock> dslDelegateMocks = IteratorExtensions.<de.fhmuenster.masterthesis.testgeneratorDSL.DelegateMock>toList(Iterators.<de.fhmuenster.masterthesis.testgeneratorDSL.DelegateMock>filter(resource.getAllContents(), de.fhmuenster.masterthesis.testgeneratorDSL.DelegateMock.class));
      final MockCreator creator = new MockCreator();
      _xblockexpression = this.delegateMocks = creator.createDelegationMock(dslDelegateMocks);
    }
    return _xblockexpression;
  }
  
  public List<ExternalServiceMock> prepareExternalServiceMocks(final Resource resource) {
    List<ExternalServiceMock> _xblockexpression = null;
    {
      final List<de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock> dslExternalServiceMocks = IteratorExtensions.<de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock>toList(Iterators.<de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock>filter(resource.getAllContents(), de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock.class));
      final MockCreator creator = new MockCreator();
      _xblockexpression = this.externalServiceMocks = creator.createExternalServiceMock(dslExternalServiceMocks);
    }
    return _xblockexpression;
  }
  
  public BPMNGenTestcase getBPMNTestcase(final Test test) {
    final BPMNGenFlow flow = this.flowMap.get(test.getFlowReference().getRef().getName());
    final BPMNGenTestcase bpmnTestcase = new BPMNGenTestcase();
    bpmnTestcase.setName(test.getName());
    bpmnTestcase.setFlow(flow);
    bpmnTestcase.setGlobalTaskVariableMap(this.globalTaskVariables);
    bpmnTestcase.setGlobalExternalTopicsMap(this.globalExternalTopicsMap);
    EList<MockReference> _mocks = test.getMocks();
    for (final MockReference mockRef : _mocks) {
      {
        final String mockName = mockRef.getRef().getName();
        final IsMock mock = this.getMockByName(mockName);
        bpmnTestcase.addMock(mock);
      }
    }
    final List<TaskVariables> taskVariables = new ArrayList<TaskVariables>();
    EList<VariableDeclarations> _declarations = test.getDeclarations();
    for (final VariableDeclarations vd : _declarations) {
      {
        final String task = vd.getTaskReference().getRef().getName();
        this.addTaskVariables(taskVariables, vd.getVariables(), task);
      }
    }
    bpmnTestcase.setTaskVariableMap(taskVariables);
    EndChecks _endCheck = test.getEndCheck();
    boolean _notEquals = (!Objects.equal(_endCheck, null));
    if (_notEquals) {
      EList<EndCheck> _endChecks = test.getEndCheck().getEndChecks();
      for (final EndCheck endCheck : _endChecks) {
        {
          if ((endCheck instanceof StringVariableEquals)) {
            String _value = ((StringVariableEquals)endCheck).getValue();
            final VariableCheck check = new VariableCheck(VariableCheckOperator.EQUALS, _value);
            bpmnTestcase.putEndCheckVariable(((StringVariableEquals)endCheck).getKey().getName(), check);
          }
          if ((endCheck instanceof IntVariableEquals)) {
            int _value_1 = ((IntVariableEquals)endCheck).getValue();
            final VariableCheck check_1 = new VariableCheck(VariableCheckOperator.EQUALS, Integer.valueOf(_value_1));
            bpmnTestcase.putEndCheckVariable(((IntVariableEquals)endCheck).getKey().getName(), check_1);
          }
          if ((endCheck instanceof BooleanVariableEquals)) {
            boolean _parseBoolean = Boolean.parseBoolean(((BooleanVariableEquals)endCheck).getValue().getName());
            final VariableCheck check_2 = new VariableCheck(VariableCheckOperator.EQUALS, Boolean.valueOf(_parseBoolean));
            bpmnTestcase.putEndCheckVariable(((BooleanVariableEquals)endCheck).getKey().getName(), check_2);
          }
          if ((endCheck instanceof StringVariableNotEquals)) {
            String _value_2 = ((StringVariableNotEquals)endCheck).getValue();
            final VariableCheck check_3 = new VariableCheck(VariableCheckOperator.NOT_EQUALS, _value_2);
            bpmnTestcase.putEndCheckVariable(((StringVariableNotEquals)endCheck).getKey().getName(), check_3);
          }
          if ((endCheck instanceof IntVariableNotEquals)) {
            int _value_3 = ((IntVariableNotEquals)endCheck).getValue();
            final VariableCheck check_4 = new VariableCheck(VariableCheckOperator.NOT_EQUALS, Integer.valueOf(_value_3));
            bpmnTestcase.putEndCheckVariable(((IntVariableNotEquals)endCheck).getKey().getName(), check_4);
          }
          if ((endCheck instanceof BooleanVariableNotEquals)) {
            boolean _parseBoolean_1 = Boolean.parseBoolean(((BooleanVariableNotEquals)endCheck).getValue().getName());
            final VariableCheck check_5 = new VariableCheck(VariableCheckOperator.NOT_EQUALS, Boolean.valueOf(_parseBoolean_1));
            bpmnTestcase.putEndCheckVariable(((BooleanVariableNotEquals)endCheck).getKey().getName(), check_5);
          }
        }
      }
    }
    return bpmnTestcase;
  }
  
  public FlowElementType getFlowElementType(final FlowElement flowElement) {
    if ((flowElement instanceof StartFlowElement)) {
      return FlowElementType.START_EVENT;
    }
    if ((flowElement instanceof EndFlowElement)) {
      return FlowElementType.END_EVENT;
    }
    if ((flowElement instanceof UserTaskFlowElement)) {
      return FlowElementType.USER_TASK;
    }
    if ((flowElement instanceof ManualTaskFlowElement)) {
      return FlowElementType.MANUAL_TASK;
    }
    if ((flowElement instanceof ScriptTaskFlowElement)) {
      return FlowElementType.SCRIPT_TASK;
    }
    if ((flowElement instanceof DelegateServiceTaskFlowElement)) {
      return FlowElementType.SERVICE_TASK_DELEGATE;
    }
    if ((flowElement instanceof ExternalServiceTaskFlowElement)) {
      return FlowElementType.SERVICE_TASK_EXTERNAL;
    }
    if ((flowElement instanceof BusinessRuleTaskFlowElement)) {
      return FlowElementType.BUSINESS_RULE_TASK;
    }
    if ((flowElement instanceof GatewayFlowElement)) {
      return FlowElementType.GATEWAY;
    }
    if ((flowElement instanceof SequenceFlowElement)) {
      return FlowElementType.SEQUENCE_FLOW;
    }
    return null;
  }
  
  public BPMNGenFlowElement createBPMNGenFlowElement(final FlowElement f) {
    final BPMNGenFlowElement flowElement = new BPMNGenFlowElement();
    final FlowElementType flowElementType = this.getFlowElementType(f);
    flowElement.setId(f.getName());
    flowElement.setType(flowElementType);
    return flowElement;
  }
  
  public IsMock getMockByName(final String mockName) {
    for (final ExternalServiceMock externalMock : this.externalServiceMocks) {
      boolean _equals = externalMock.getName().equals(mockName);
      if (_equals) {
        return externalMock;
      }
    }
    for (final DelegateMock delegateMock : this.delegateMocks) {
      boolean _equals_1 = delegateMock.getName().equals(mockName);
      if (_equals_1) {
        return delegateMock;
      }
    }
    return null;
  }
  
  public boolean isDeclarationType(final FlowElementType type) {
    boolean _equals = FlowElementType.SEQUENCE_FLOW.equals(type);
    return (!_equals);
  }
  
  public void prepareGlobalExternalTopics(final Resource resource) {
    final List<ExternalServiceTaskFlowElement> externalServiceTasks = IteratorExtensions.<ExternalServiceTaskFlowElement>toList(Iterators.<ExternalServiceTaskFlowElement>filter(resource.getAllContents(), 
      ExternalServiceTaskFlowElement.class));
    for (final ExternalServiceTaskFlowElement externalServiceTask : externalServiceTasks) {
      {
        final String externalTopicName = externalServiceTask.getExternalTopic().getRef().getName();
        this.globalExternalTopicsMap.put(externalServiceTask.getName(), externalTopicName);
      }
    }
  }
  
  public void prepareGlobalTaskVariables(final Resource resource) {
    final List<ExternalServiceTaskFlowElement> externalServiceTasks = IteratorExtensions.<ExternalServiceTaskFlowElement>toList(Iterators.<ExternalServiceTaskFlowElement>filter(resource.getAllContents(), 
      ExternalServiceTaskFlowElement.class));
    for (final ExternalServiceTaskFlowElement externalServiceTask : externalServiceTasks) {
      {
        final String task = externalServiceTask.getName();
        final List<VariableDeclaration> declarations = externalServiceTask.getHardcodedInputs();
        this.addGlobalTaskVariables(this.globalTaskVariables, declarations, task);
      }
    }
  }
  
  public boolean addTaskVariables(final List<TaskVariables> taskVariables, final List<VariableDeclaration> declarations, final String task) {
    boolean _xblockexpression = false;
    {
      final HashMap<String, Object> variableMap = new HashMap<String, Object>();
      for (final VariableDeclaration v : declarations) {
        {
          if ((v instanceof StringVariableDeclaration)) {
            this.putTaskVariable(variableMap, ((StringVariableDeclaration)v).getKey().getName(), ((StringVariableDeclaration)v).getValue());
          }
          if ((v instanceof IntVariableDeclaration)) {
            this.putTaskVariable(variableMap, ((IntVariableDeclaration)v).getKey().getName(), Integer.valueOf(((IntVariableDeclaration)v).getValue()));
          }
          if ((v instanceof BooleanVariableDeclaration)) {
            this.putTaskVariable(variableMap, ((BooleanVariableDeclaration)v).getKey().getName(), 
              Boolean.valueOf(Boolean.parseBoolean(((BooleanVariableDeclaration)v).getValue().getName())));
          }
        }
      }
      final TaskVariables taskVariablesObj = new TaskVariables();
      taskVariablesObj.setTask(task);
      taskVariablesObj.setVariables(variableMap);
      _xblockexpression = taskVariables.add(taskVariablesObj);
    }
    return _xblockexpression;
  }
  
  public void putTaskVariable(final HashMap<String, Object> variableMap, final String variableKey, final Object variableValue) {
    variableMap.put(variableKey, variableValue);
  }
  
  public HashMap<String, HashMap<String, Object>> addGlobalTaskVariables(final HashMap<String, HashMap<String, Object>> taskVariables, final List<VariableDeclaration> declarations, final String task) {
    for (final VariableDeclaration v : declarations) {
      {
        if ((v instanceof StringVariableDeclaration)) {
          this.putGlobalTaskVariable(taskVariables, task, ((StringVariableDeclaration)v).getKey().getName(), ((StringVariableDeclaration)v).getValue());
        }
        if ((v instanceof IntVariableDeclaration)) {
          this.putGlobalTaskVariable(taskVariables, task, ((IntVariableDeclaration)v).getKey().getName(), Integer.valueOf(((IntVariableDeclaration)v).getValue()));
        }
        if ((v instanceof BooleanVariableDeclaration)) {
          this.putGlobalTaskVariable(taskVariables, task, ((BooleanVariableDeclaration)v).getKey().getName(), 
            Boolean.valueOf(Boolean.parseBoolean(((BooleanVariableDeclaration)v).getValue().getName())));
        }
      }
    }
    return null;
  }
  
  public void putGlobalTaskVariable(final HashMap<String, HashMap<String, Object>> taskVariableMap, final String task, final String variableKey, final Object variableValue) {
    HashMap<String, Object> _hashMap = new HashMap<String, Object>();
    final HashMap<String, Object> taskVariables = taskVariableMap.getOrDefault(task, _hashMap);
    taskVariables.put(variableKey, variableValue);
    taskVariableMap.put(task, taskVariables);
  }
}
